# =============================================================================
# Wizard of Oz - Runtime module
# =============================================================================
#	Version			Version 2.30 Copyright (c) 2001-08 Richard Breuer
#	Date				December 20, 2008
#
#	Startprompt	P004
#	WOZ-Dir			C:/Program Files/woz/export
#
#	Title				Wizard of Oz - Malibu Beach Hotel Reservation System (hotel.woz)
#	TTS Prompts	Enter string
# =============================================================================

# =============================================================================
#	This file has been generated with WOZ - do not edit!
# =============================================================================

set plugin(wav) ""
set plugin(pic) ""
set plugin(autoplay) 1
set plugin(autostop) 1

set options(CONDLENGTH) 20

#-------------------------------------------------------------------------- TCL
# check tcl version
if {$tcl_version<"8.3"} {
  puts "FATAL ERROR:\n\nTcl/Tk must be at least version 8.3!"
  exit
}
# check tk availability
if {[info commands button]==""} {
  puts "FATAL ERROR:\n\nThis program requires wish!"
  exit
}

wm withdraw .

# ----------------------------------------------------------------------- SNACK
# WOz needs snack >=2.2 to replay sound files
if {[catch {set woz(snack) [package require snack]}]} {
	set woz(snack) ""
	tk_messageBox -type ok -message "WARNING:\n\nPackage 'snack' is not installed!\nWOz cannot play soundfiles."
} elseif {$woz(snack)<"2.2"} {
	set woz(snack) ""
	tk_messageBox -type ok -message "WARNING:\n\nPackage 'snack' is too old, v2.2 is required!\nWOz cannot play soundfiles."
}

# ------------------------------------------------------------------------- DIR
# get script root
set woz(DIR) "[file dirname [info script]]"
if {$woz(DIR)==""} {
  # correct this if you want to source...
  set woz(DIR) .
}

# check script root
if {![file exists $woz(DIR)/share/run.tcl]} {
	set woz(DIR) "C:/Program Files/woz/export"
}
if {![file exists $woz(DIR)/share/run.tcl]} {
  tk_messageBox -type ok -message "FATAL ERROR:\n\nCannot determine script root directory.
Copy the export/share folder from WOz under your new script!"
	exit
}

# ----------------------------------------------------------------------- TCOM
# WOz needs tcom >=3.7 to create TTS output
if {[catch {set woz(tcom) [package require tcom]}]} {
	set woz(tcom) ""
	tk_messageBox -type ok -message "WARNING:\n\nPackage 'tcom' is not installed!\nWOz cannot play TTS prompts."
} elseif {$woz(tcom)<"3.7"} {
	set woz(tcom) ""
	tk_messageBox -type ok -message "WARNING:\n\nPackage 'tcom' is too old, v2.2 is required!\nWOz cannot play TTS prompts."
}

# ----------------------------------------------------------------------- SAPI
if {$woz(tcom)!=""} {
	if {[catch {set woz(sapi) [::tcom::ref createobject Sapi.SpVoice]}]} {
		set woz(sapi) ""
		tk_messageBox -type ok -message "WARNING:\n\nNo SAPI voice is installed!\nWOz cannot play TTS prompts."
		set var(tts) 0
	} else {
		set var(tts) 1
	}
}

# ------------------------------------------------------------------------- LOG
# get log file name
set woz(LOGFILE) "[file rootname [info script]].log"

#-------------------------------------------------------------------------- RES
set woz(RES) $woz(DIR)/share
set woz(sort) 1
set plugin(restrictive) 1
set plugin(currentid) P004
set woz(win_choose) "Choose File"
set woz(win_entertts) "Enter string"

proc splash {{ms 0}} {
    global woz
    update idletasks
    if {[winfo exists .x]} return
    toplevel .x -bd 3 -relief raised
    wm withdraw .x
    set sw [winfo screenwidth .]
    set sh [winfo screenheight .]
    image create photo "title" -file $woz(RES)/woz.gif
    wm overrideredirect .x 1
    label .x.l -image title -bd 1 -relief sunken
    frame .x.f
    label .x.f.a -bd 1 -relief raised -background yellow -text "Version 2.30 Copyright (c) 2001-08 Richard Breuer - December 20, 2008"
    button .x.f.b -command {catch {grab release .x; destroy .x}} -textvar label(close)
    pack .x.l -side top -expand 1 -fill both
    pack .x.f.a -side left -expand 1 -fill both
    pack .x.f.b -side left
    pack .x.f -side top -fill x
    set x [expr {($sw - [image width title])/2}]
    set y [expr {($sh - [image height title])/2}]
    wm geometry .x +$x+$y
    wm deiconify .x
    raise .x
    focus .x
    if {$ms==0} {
	    bind .x <Key-Return> {.x.f.b invoke}
	    bind .x <Key-Escape> {.x.f.b invoke}
    }
    update idletasks
    if {$ms>0} {
      after $ms {catch {destroy .x}}
    } else {
      grab .x
      tkwait window .x
    }
}

proc log {str} {
  global woz

  # replace newlines in the log string by ~ to create a smoother output
  regsub -all "\n" $str "~" str

  # log the string with a time stamp
  puts $woz(log) "[clock format [clock seconds] -format "%y%m%d%H%M%S"]\t$str"
}

proc logDia {id which who str} {
  global woz

  # replace newlines in the log string by ~ to create a smoother output
  regsub -all "\n" $str "~" str

  # log the string with a time stamp
  puts $woz(dia) "$id\t$which\t$who\t$str"
}

#========================================================================= MAIN
cd $woz(DIR)
source $woz(RES)/run.tcl
source $woz(RES)/util.tcl
source $woz(RES)/balloon.tcl
source $woz(RES)/undo.tcl
source $woz(RES)/dia.tcl
source $woz(RES)/play.tcl
source $woz(RES)/canvas.tcl
source $woz(RES)/mini.tcl
source $woz(RES)/ini.tcl

ini::Read $woz(RES)/run.ini
set woz(wav_dir) "C:/Program Files/woz/prompts"

# initializations
set woz(log) [open $woz(LOGFILE) a]
puts $woz(log) "-------------------------------------------------------------------------------"
log "WOZ Session started (Version 2.30 Copyright (c) 2001-08 Richard Breuer)"
moveInit

array set plugin {
        pix,vars        {p_id p_follows p_start p_title}
        pix,text        {p_prompt p_memo}
        qix,vars        {q_id q_concepts q_follows q_title}
        qix,text        {q_memo q_init q_nu1 q_nu2 q_nu3 q_nr1 q_nr2 q_nr3 q_tl1 q_tl2 q_tl3 q_ctxhelp}
        cix,vars        {c_id c_name c_always c_title}
        cix,text        {c_memo}
}

array set plugin {
Q001,q_tl1_bi 1 Q001,q_follows {P002 Q002 Q003 Q004} Q001,p_title Q001 Q002,c_title Q002 Q002,q_id Q002 Q001,q_reachable 0 Q004,q_init {Which type of room would you like?[A:hotel/Q004.q_init.wav]} Q003,q_nr3_bi 1 Q001,q_ctxhelp {With this application, you can book rooms at the Malibu Beach hotel.[A:hotel/Q001.q_ctxhelp.wav]} Q002,q_nr1_bi 0 Q002,q_init {When would you like to arrive?[A:hotel/Q002.q_init.wav]} Q003,q_nu2_bi 1 Q002,q_tl2_bi 0 Q003,q_follows {P002 Q003 Q004} Q001,q_concepts {C004 C005 C006} Q002,x 20.0 Q002,y 240.0 Q004,id Q004 Q003,q_ctxhelp {} Q002,q_title Arrival Q003,q_nr2_bi 1 Q001,q_init_bi 1 Q003,q_memo {duration of the visit} Q004,q_nu3_bi 1 Q004,q_tl1 {} Q004,q_tl2 {} Q004,q_tl3 {} Q003,q_tl3_bi 1 Q003,q_nu1_bi 1 Q002,q_concepts C004 Q002,p_title Q002 Q002,q_tl1_bi 1 Q004,q_ctxhelp_bi 1 Q001,q_memo {Open question at the beginning, no error handling} Q003,c_title Q003 Q003,q_tl1 {} Q003,q_tl2 {} Q003,q_tl3 {} Q004,q_vxml 0 Q003,id Q003 Q003,q_init_bi 1 Q004,q_nr3_bi 1 Q004,q_id Q004 Q003,q_concepts C006 Q002,q_tl1 {That was too much for me. Try again, please.[A:hotel/Q002.q_tl1.wav]} Q002,q_tl2 {That was too much information again. One moment please, I transfer you to an operator.[A:hotel/Q002.q_tl2.wav]} Q003,q_ctxhelp_bi 1 Q002,q_tl3 {} Q003,q_nr1_bi 1 Q001,q_id Q001 Q002,q_vxml 0 Q001,q_nu3_bi 1 Q004,q_nu2_bi 1 Q003,q_tl2_bi 1 Q001,q_tl1 {} Q001,q_tl2 {} Q001,q_tl3 {} Q004,q_concepts C005 Q002,q_ctxhelp_bi 1 Q003,q_title Duration Q003,x 460.0 Q003,y 280.0 Q001,q_nr3_bi 1 Q002,id Q002 Q004,q_nr2_bi 1 Q003,p_title Q003 Q001,q_nu2_bi 1 Q004,c_title Q004 Q001,q_endstate 0 Q004,q_tl3_bi 1 Q004,q_nu1_bi 0 Q001,q_ctxhelp_bi 1 Q004,q_nr1 {} Q003,q_tl1_bi 1 Q004,q_nr2 {} Q003,q_init {How long would you like to stay?[A:hotel/Q003.q_init.wav]} Q004,q_nr3 {} Q002,q_follows {P002 Q002 Q004 Q003} Q003,q_nr1 {} Q001,q_init {How can I help you?[A:hotel/Q001.q_init.wav][P:hotel/Q001.q_init.gif]} Q003,q_nr2 {} Q003,q_nr3 {} Q002,q_endstate 0 Q002,q_ctxhelp {Please state the date of your arrival like 'the first of May'. You can use common holiday expressions like 'Easter' or 'Christmas' as well.[A:hotel/Q002.q_ctxhelp.wav]} Q001,q_nr2_bi 1 Q001,id Q001 Q004,q_nr1_bi 1 Q004,q_nu1 {Sorry? You can book a single or a double room. We offer honeymoon and president suites as well.[A:hotel/Q004.q_nu1.wav] {REPROMPT}} Q004,q_nu2 {Sorry, I did not get that! Please tell me, which type of room you'd like.[A:hotel/Q004.q_nu2.wav]} Q002,q_nu3_bi 1 Q004,q_nu3 {} Q004,q_reachable 0 Q002,q_nr1 {Please speak to me![A:hotel/Q002.q_nr1.wav]} Q002,q_nr2 {The phone line seems to have a problem. Try again later, please.[A:hotel/Q002.q_nr2.wav]} Q002,q_nr3 {} Q001,q_tl3_bi 1 Q001,q_nu1_bi 1 Q004,q_tl2_bi 1 Q003,q_id Q003 Q004,q_follows {P002 Q002 Q003 Q004} Q004,q_memo {question for the room type} Q004,q_title Room Q003,q_nu1 {} Q003,q_nu2 {} Q003,q_nu3 {} Q001,q_nr1 {} Q003,q_endstate 0 Q001,q_nr2 {} Q001,q_nr3 {} Q002,q_memo {Ask for the arrival date} Q004,q_ctxhelp {Say 'single' or 'double' room, 'honeymoon' or 'president suite' now.[A:hotel/Q004.q_ctxhelp.wav]} Q001,c_title Q001 Q004,p_title Q004 Q002,q_nu1 {Sorry, I didn't understand you. Please say the date of your arrival now.[A:hotel/Q002.q_nu1.wav]} Q002,q_nr3_bi 1 Q002,q_nu2 {Sorry, I still didn't get you. Please use common date expressions like 'the first of May' or usual holidays.[A:hotel/Q002.q_nu2.wav]} Q002,q_nu3 {One moment please, I transfer you to an operator.[A:hotel/Q002.q_nu3.wav]} Q002,q_init_bi 1 Q003,q_reachable 0 Q004,x 80.0 Q001,q_nr1_bi 1 Q004,y 40.0 Q002,q_nu2_bi 1 Q004,q_endstate 0 Q001,q_nu1 {} Q001,q_tl2_bi 1 Q001,q_nu2 {} Q001,q_nu3 {} Q004,q_tl1_bi 1 Q001,x 340.0 Q003,q_vxml 0 Q001,y 120.0 Q001,q_vxml 0 Q002,q_reachable 0 Q004,q_init_bi 1 Q002,q_nr2_bi 1 Q001,q_title Start Q003,q_nu3_bi 1 Q002,q_tl3_bi 0 Q002,q_nu1_bi 1 P003,p_memo {Adios, amigo. At last, a song is played.} P004,p_vxml 0 P005,p_follows {} P005,id P005 P002,q_title P002 P002,p_start {} P004,x 340.0 P004,p_prompt {Good morning.<esc>P4 Welcome to the
Malibu Beach hotel reservation system! {A:hotel/P001.p_prompt.wav,hotel/P001.p_prompt_hello.wav,hotel/P001.p_prompt_hi.wav}[P:hotel/P001.p_prompt.gif]} P004,y 20.0 P002,p_vxml 0 P002,p_endstate 0 P002,p_title ID P003,c_title P003 P004,p_id P004 P004,id P004 P003,p_endstate 0 P005,p_reachable 1 P004,p_endstate 0 P003,q_title P003 P003,p_start {} P004,p_reachable 0 P002,p_follows P003 P003,id P003 P003,p_title Bye P005,p_prompt {Please wait for the next available operator!} P004,c_title P004 P005,p_endstate 1 P005,x 460.0 P005,y 420.0 P004,p_memo {} P003,p_reachable 0 P002,x 220.0 P002,y 320.0 P002,p_memo {The number is generated with a transaction} P005,p_prompt_bi 1 P004,p_follows Q001 P002,id P002 P005,p_vxml 0 P002,p_prompt {Your reservation ID is 0-1-1-2-2.[A:hotel/P002.p_prompt.wav][A:hotel/0.wav][A:hotel/1.wav][A:hotel/1.wav,hotel/2.wav]{A:hotel/1.wav,hotel/2.wav}[A:hotel/2.wav][A:...]} P003,p_id P003 P004,q_title P004 P002,p_reachable 0 P003,p_vxml 0 P004,p_start 1 P004,p_prompt_bi 0 P004,p_title Welcome P005,c_title P005 P003,p_prompt_bi 1 P003,x 220.0 P003,y 420.0 P003,p_prompt {Thank you for using our service. Good-bye![A:hotel/P003.p_prompt.wav] <Song> [A:hotel/pause_500.wav][A:hotel/song.wav]} P005,q_title P005 P005,p_start {} P002,p_prompt_bi 1 P005,p_id P005 P005,p_title P005 P002,c_title P002 P002,p_id P002 P005,p_memo {} P003,p_follows {} O,Q002,Q002 {arrival is still undefined} O,Q002,Q003 {{VALUE} == 'today[A:hotel/today.wav]'} O,Q002,Q004 {room type is undefined} O,Q002,P002 {all slots are defined} O,Q004,Q002 {arrival is undefined} O,Q004,Q003 {duration is undefined} O,Q004,Q004 {room type is still undefined} O,Q001,Q002 {arrival is undefined} O,Q001,Q003 {duration is undefined} O,Q001,Q004 {room type is undefined} O,Q004,P002 {all slots are defined} O,Q001,P002 {all slots are defined} O,Q003,Q003 {duration is still undefined} O,Q003,Q004 {room type is undefined} O,Q003,P002 {all slots are defined} C005,c_memo {{[a] single room | [a] double room | [a | the] honeymoon suite} [please]} C006,c_name duration C004,id C004 C004,c_name arrival C001,c_memo {[i {need | want | request}] {help | assistance | guidance} [please]} C002,c_name repeat C004,c_title {Arrival Date} C004,c_always {} C006,c_id C006 C002,id C002 C001,c_always 1 C004,q_title C004 C004,p_title C004 C001,c_title {Help Request} C005,c_title {Room Type} C001,id C001 C006,c_memo {[i will stay] [for] {one | two | three | four | five | six | seven | eight | nine} {days | nights | weeks} [please]} C005,c_always {} C004,c_memo {[the] {twentieth | thirtieth | [twenty | thirty] {first | second | third | fourth | fifth | sixth | seventh | eighth | nineth}}
of {january | february | march | april | may | june | july | august |  september | october | november | december} [please]} C005,c_name room_type C002,c_memo {{repeat [that] | replay [that] | [say [that]] again} [please]} C001,q_title C001 C005,c_id C005 C005,q_title C005 C002,c_id C002 C002,c_always 1 C001,p_title C001 C001,c_name help C002,c_title Repetition C005,p_title C005 C006,c_title Duration C006,id C006 C006,c_always {} C002,q_title C002 C006,q_title C006 C005,id C005 C002,p_title C002 C006,p_title C006 C004,c_id C004 C001,c_id C001
}

array set label {
opt,p_prompt {Prompt text} sc_update_header {Text Synchronization} opt,q_ctxhelp_bi {Unkown res 'b_label_q_ctxhelp_bi' ('')} opt,q_title Title sc_update_design {Change design texts} opt,q_tl3_bi {Unkown res 'b_label_q_tl3_bi' ('')} opt,p_start {Welcome Prompt?} opt,q_nu1_bi {Unkown res 'b_label_q_nu1_bi' ('')} opt,p_vxml {Unkown res 'b_label_p_vxml' ('')} opt,s_id {Unkown res 'b_label_s_id' ('')} sc_mandatory_states {Mandatory states} yes Yes sc_sync_header {Objects to synchronize} opt,c_header Concept sc_max_length {Max number of Dialog States} opt,run_log Log! no No opt,q_memo Comment opt,q_concepts {Recognizable Concepts} opt,c_memo {Comment / Grammar} opt,p_title Title opt,q_tl1_bi {Unkown res 'b_label_q_tl1_bi' ('')} ok Ok opt,c_title Title opt,q_nu1 {Retry 1} opt,exc,tl {Probability of <Confirmation> in %} opt,q_nr3_bi {Unkown res 'b_label_q_nr3_bi' ('')} opt,q_id {Unkown res 'b_label_q_id' ('')} opt,q_nu2 {Retry 2} opt,q_init_bi {Unkown res 'b_label_q_init_bi' ('')} opt,q_nu3 {Retry 3} opt,s_call {Dialog Turns} sc_do_nothing {Keep texts unchanged} prompt P opt,s_header {Sample Call} sc_min_length {Min number of Dialog States} opt,c_name Name opt,p_follows {Possible Followups} opt,q_follows {Possible Followups} opt,q_nu2_bi {Unkown res 'b_label_q_nu2_bi' ('')} close Close opt,s_memo Comment none None endstate End? opt,q_predecessors Predecessors opt,q_nr1_bi {Unkown res 'b_label_q_nr1_bi' ('')} changed M sc_sync Choose opt,run_indexsort Ix opt,q_init {Initial Prompt} opt,exc,nr {Probability of <Timeout> in %} opt,run_namesort Name opt,p_memo Comment sc_create_missing_obj {Create deleted objects} opt,p_reachable {Unkown res 'b_label_p_reachable' ('')} opt,p_endstate {Unkown res 'b_label_p_endstate' ('')} opt,exc,nu {Probability of <Retry> in %} apply Apply cancel Cancel sc_update_calls {Change sample call texts} opt,run_condsort Cond append_p {Append Prompt} opt,q_tl1 {Confirmation 1} opt,q_header Question append_q {Append Question} sc_create_new_concepts {Create concepts} all All opt,q_tl2 {Confirmation 2} loaded {} opt,s_name Name opt,p_prompt_bi {Unkown res 'b_label_p_prompt_bi' ('')} opt,q_tl3 {Confirmation 3} opt,q_tl2_bi {Unkown res 'b_label_q_tl2_bi' ('')} set_name {Unkown res 'set_name' ('')} concept C opt,q_vxml {Unkown res 'b_label_q_vxml' ('')} sc_max_occurrences {Max number of loops} opt,q_endstate {Unkown res 'b_label_q_endstate' ('')} opt,q_ctxhelp {Context Sensitive Help} opt,p_header Prompt reachable {Always Reachable?} opt,run_textsort Text question Q sc_create_header {Object Synchronization} sc_ends_at_end {Calls must reach an End State} default {Restore Defaults} opt,c_id {Unkown res 'b_label_c_id' ('')} opt,q_reachable {Unkown res 'b_label_q_reachable' ('')} opt,o_header Connection opt,q_nu3_bi {Unkown res 'b_label_q_nu3_bi' ('')} barge_in Barge-In opt,q_nr1 {Timeout 1} opt,p_predecessors Predecessors opt,q_nr2 {Timeout 2} opt,q_nr3 {Timeout 3} opt,exc,re {Probability of <Misrecognition> in %} opt,c_always {Always Active?} opt,q_nr2_bi {Unkown res 'b_label_q_nr2_bi' ('')} opt,p_id {Unkown res 'b_label_p_id' ('')} opt,exc,header {Exception Settings} opt,o_condition Condition sc_create_new_obj {Create new objects} sc_create_new_connections {Create connections} opt,c_usedby {Used By} opt,c_check {Check BNF} vxml {VXML Code}
}

array set options {
sc_ends_at_end 1 exc_nu 5 ix,version 0 exc_on 0 sc_create_missing_obj 1 exc_nunu 0 exc_re 6 sc_mandatory_states {} sc_create_new_concepts 1 ix,options 1 sc_min_length 1 sc_update_wordings update_calls sc_create_new_connections 1 sc_create_new_obj 1 sc_max_length 999 ix,woz 2 sc_max_occurrences 1 exc_nrnr 1 exc_nr 2 exc_tl 1
}

initCanvas

proc rNum {} {
  # produce a random number between 0 and 100
  return [expr round(100.0*rand())]
}

proc throwEvent {str} {
  global widget label

  log "Event|$str"

  set label(exc) $str
  Window show $widget(winexc)
  grab $widget(winexc)
  focus $widget(winexc)
  raise $widget(winexc)
  tkwait window $widget(winexc)
}

proc allEntries {type} {
  global plugin
 
  # return a list of all ids from a certain type
  set ret {}
  set tmp [array names plugin *,[string tolower $type]_id]
  foreach n [lsort $tmp] {
    lappend ret [lindex [split $n ","] 0]
  }
  return $ret
}

proc resortList {} {
  global woz widget
  #puts "sorting order is now $woz(sort)"
 
  proc cmpEl {a b} {
    global woz
    set la [split $a "|"]
    set lb [split $b "|"]
    if {[lindex $la $woz(sort)]<[lindex $lb $woz(sort)]} {return -1}
    if {[lindex $la $woz(sort)]>[lindex $lb $woz(sort)]} {return 1}
    return 0
  }
 
  set elList [$widget(followlist) get 0 end]
  set elList [lsort -command cmpEl $elList]
  $widget(followlist) delete 0 end
  foreach e $elList {
    $widget(followlist) insert end $e
    if {[string index $e 0]=="P"} {
      $widget(followlist) itemconfigure end -background [ini::Str common.colorP]
    } else {
      $widget(followlist) itemconfigure end -background [ini::Str common.colorQ]
    }
  }
}

proc getAndSwitch {} {
  # get the current followup selection and switch to it
  global widget
 
  # get the current selection index
  set sel [$widget(followlist) curselection]
  if {$sel==""} {return}
 
  # get the selected element
  set sel [$widget(followlist) get $sel]
  if {$sel==""} {return}
 
  # the the interesting part before |
  set p [string first "|" $sel]
  if {$p==-1} {return}
  set sel [string range $sel 0 [expr $p-1]]
 
  # switch to that element
  switchAndStore $sel
}

proc switchAndStore {id} {
  global plugin

  # store move for undo/redo
  moveAdd "switchEntry $id" "switchEntry $plugin(currentid)"
}

proc ableButtons {id field} {
	global plugin widget
	
	if {$plugin($id,[set field]_bi) && $plugin($id,$field)!=""} {
		$widget(stop,$field) configure -state normal
	} else {
		$widget(stop,$field) configure -state disabled
	}
	if {$plugin($id,$field)!=""} {
		$widget(ls,$field) configure -state normal
	} else {
		$widget(ls,$field) configure -state disabled
	}
}

proc isPrompt {id} {
	if {[string tolower [string index $id 0]]=="p"} {return 1}
	return 0
}

proc isQuestion {id} {
	if {[string tolower [string index $id 0]]=="q"} {return 1}
	return 0
}

proc isConnected {tag1 tag2} {
	global plugin

	# check for always reachable target
	if {[isPrompt $tag2]} {
		if {$plugin($tag2,p_reachable)==1} {return 1}
	} else {
		if {$plugin($tag2,q_reachable)==1} {return 1}
	}

	# examine the follows list
	if {[isPrompt $tag1]} {set w p_follows} else {set w q_follows}
	return [expr [lsearch -exact $plugin($tag1,$w) $tag2]!=-1]
}

proc calcSuccessors {id} {
	# return a list of follow up id's
	global plugin

	set ret {}
	foreach n [concat [allEntries P] [allEntries Q]] {
		if {[isConnected $id $n]} {lappend ret $n}
	}

	return [lsort -uniq $ret]
}

proc switchEntry {id} {
  # switch to prompt or question
  global widget plugin global status options curobj

  # empty the destroy event
  bind $widget(main) <Destroy> {}

  # remove the old windows
  catch {pack unpack $widget(p)}
  catch {pack unpack $widget(q)}
  $widget(followlist) delete 0 end

  # pack the right one
  set type [string tolower [string index $id 0]]
  pack $widget($type) -expand 1 -fill both

  # show the current status information
  incr global(turns)
  set status(turns) "$global(turns) Turns"
  set plugin(currentid) $id

  # set the appropriate values
  switch $type {
    p {
      # write logs
      log "$global(turns)|$id|$plugin($id,p_title)|$plugin($id,p_prompt)"

      foreach n $plugin(pix,vars) { set curobj($n) $plugin($id,$n) }
      foreach n $plugin(pix,text) {
        $widget($n) delete 0.0 end
        $widget($n) insert end $plugin($id,$n)
      }

			# configure stop and play buttons
			ableButtons $id p_prompt

      # in non restrictive mode all entries can be reached
      if {$plugin(restrictive)} {
				if {$plugin($id,p_endstate)==1} {
				  set status(msg) "Switched to $id (end state)"
	        set list {}
				} else {
				  set status(msg) "Switched to $id"
	        set list [calcSuccessors $id]
				}
      } else {
        set list [concat [allEntries P] [allEntries Q]]
      }

      # create a button for each possible followup
      catch {eval destroy [winfo children $widget(p_follows)]}
      foreach n $list {
        if {[string index $n 0]=="P"} {
          $widget(followlist) insert end "$n|[util::value plugin(O,$id,$n) $options(CONDLENGTH)]|$plugin($n,p_title)|$plugin($n,p_prompt)"
        } else {
          $widget(followlist) insert end "$n|[util::value plugin(O,$id,$n) $options(CONDLENGTH)]|$plugin($n,q_title)|$plugin($n,q_init)"
        }
      }

			# autoplay
			if {$plugin(autoplay)} {
				after 0 {playPrompt p_prompt}
			}
    }
    q {
      # write logs
      log "$global(turns)|$id|$plugin($id,q_title)|$plugin($id,q_init)"

      foreach n $plugin(qix,vars) { set curobj($n) $plugin($id,$n) }
      foreach n $plugin(qix,text) {
        $widget($n) delete 0.0 end
        $widget($n) insert end $plugin($id,$n)
      }

			# configure stop and play buttons
			ableButtons $id q_init
			ableButtons $id q_nu1
			ableButtons $id q_nu2
			ableButtons $id q_nu3
			ableButtons $id q_nr1
			ableButtons $id q_nr2
			ableButtons $id q_nr3
			ableButtons $id q_tl1
			ableButtons $id q_tl2
			ableButtons $id q_tl3
			ableButtons $id q_ctxhelp

      # in non restrictive mode all entries can be reached
      if {$plugin(restrictive)} {
				if {$plugin($id,q_endstate)==1} {
				  set status(msg) "Switched to $id (end state)"
	        set list {}
				} else {
				  set status(msg) "Switched to $id"
	        set list [calcSuccessors $id]
				}
      } else {
        set list [concat [allEntries P] [allEntries Q]]
      }

      # create a button for each possible followup
      catch {eval destroy [winfo children $widget(q_follows)]}
      foreach n $list {
        if {[string index $n 0]=="P"} {
          $widget(followlist) insert end "$n|[util::value plugin(O,$id,$n) $options(CONDLENGTH)]|$plugin($n,p_title)|$plugin($n,p_prompt)"
        } else {
          $widget(followlist) insert end "$n|[util::value plugin(O,$id,$n) $options(CONDLENGTH)]|$plugin($n,q_title)|$plugin($n,q_init)"
        }
      }

      # create a (disabled) button for each concept
      catch {eval destroy [winfo children $widget(q_concepts_alw)]}
      catch {eval destroy [winfo children $widget(q_concepts)]}

      foreach n [lsort $plugin(alw)] {
				set w [string tolower $widget(q_concepts_alw).$n]
        button $w -text "$plugin($n,c_title)" -state disabled -background [ini::Str common.colorC] \
        	-disabledforeground #000040
        set tmp "$plugin($n,c_name) - $plugin($n,c_memo)"
        if {[string length $tmp]>[ini::Str common.conceptBubbleLength]} {
					set tmp "[string range $tmp 0 [expr [ini::Str common.conceptBubbleLength]-1]]..."
				}
				balloon $w $tmp
	      pack $w -side left
			}

	    foreach n [lsort $plugin($id,q_concepts)] {
				set w [string tolower $widget(q_concepts).$n]
		    button $w -text "$plugin($n,c_title)" -state disabled -background [ini::Str common.colorC] \
		    	-disabledforeground #000040
		    set tmp "$plugin($n,c_name) - $plugin($n,c_memo)"
        if {[string length $tmp]>[ini::Str common.conceptBubbleLength]} {
					set tmp "[string range $tmp 0 [expr [ini::Str common.conceptBubbleLength]-1]]..."
				}
				balloon $w $tmp
		    pack $w -side left
		  }

			# autoplay
			if {$plugin(autoplay)} {
				after 0 {playPrompt q_init}
			}
	  }
	}

  # sort the list
  resortList

	# display the mini entry
	miniDisplay $id

  # re-restablish the destroy event
  bind $widget(main) <Destroy> {menuCommand file,exit}

  if {$type=="q" && $plugin(exc)==1} {
    # generate a random event from time to time
    if {[rNum]<$options(exc_nu)} {
      throwEvent "TIMEOUT"
    } elseif {[rNum]<$options(exc_nr)} {
      throwEvent "RETRY"
    } elseif {[rNum]<$options(exc_tl)} {
      throwEvent "CONFIRMATION"
    } elseif {[rNum]<$options(exc_re)} {
      throwEvent "Misrecognition"
    }
  }
}

proc menuCommand {cmd} {
  global global woz
  switch $cmd {
    file,exit {
      catch {close $woz(log)}
      catch {close $woz(dia)}
      exit
    }
    run,restart {
      log "Restart -------------------------------------------------------------------------------"
      set global(time) [clock seconds]
      set global(turns) 0

			# create a dialog log
			catch {close $woz(dia)}
			set woz(DIAFILE) "$woz(rootname).[clock format [clock seconds] -format %y%m%d%H%M%S].log"
			set woz(dia) [open $woz(DIAFILE) w]

      switchEntry P004
    }
    run,undo {
      log "Undo"
      logDia "" "" "<undo>" "..."
      moveUndo
    }
    run,redo {
      log "Redo"
      logDia "" "" "<Redo>" "..."
      moveRedo
    }
    help,about {
      splash
    }
  }
}

proc setTime {} {
  global status global

  set status(time) [clock format [expr [clock seconds]-$global(time)] -format "%M:%S"]
  after 1000 setTime
}

proc setDate {} {
  global status

  set status(date) [clock format [clock seconds] -format "%c"]
}

proc playPrompt {which} {
	global cmd plugin status
	
	log "play|$plugin(currentid)|$which|$plugin($plugin(currentid),$which)"
  logDia $plugin(currentid) $which "System" "$plugin($plugin(currentid),$which)"

	if {$plugin(autostop)} {
		catch {$plugin(wav) destroy}
	}

	set plugin(wav) [play::prompt $plugin($plugin(currentid),$which) 1]
	if {$plugin(wav)!=""} {
		$plugin(wav) play
		set destroyAfter [expr 2+round(1000*[$plugin(wav) length -unit SECONDS])]
		after $destroyAfter "catch \"$plugin(wav) destroy\""
	}

	set plugin(pic) [play::picture $plugin($plugin(currentid),$which)]
}

proc stopPrompt {which} {
	global cmd plugin status

	catch {$plugin(wav) stop}
	catch {destroy $plugin(pic)}
}

displayMiniImage

# calculate a list of always active concepts
set plugin(alw) {}
foreach n [array names plugin C*,c_id] {
  set id [lindex [split $n ","] 0]
  if {$plugin($id,c_always)==1} {lappend plugin(alw) $id}
}

# set window titles
wm title $widget(main) "Wizard of Oz - Malibu Beach Hotel Reservation System (hotel.woz)"
wm title $widget(winexc) "Random Exception"

Window hide $widget(winexc)

# set language values
$widget(mm_file) configure -text "File"
$widget(mm_run)  configure -text "Run"
$widget(mm_help) configure -text "Help"

$widget(m_file) entryconfigure 0 -label "Exit"

$widget(m_run)  entryconfigure 0 -label "Restart"
$widget(m_run)  entryconfigure 2 -label "Back"
$widget(m_run)  entryconfigure 3 -label "Forward"
$widget(m_run)  entryconfigure 5 -label "Restrictive Navigation"
$widget(m_run)  entryconfigure 6 -label "Random Exceptions"
$widget(m_run)  entryconfigure 7 -label "Prompt Autoplay"
$widget(m_run)  entryconfigure 8 -label "Prompt Autostop"
$widget(m_run)  entryconfigure 10 -label "Text-to-Speech"

$widget(m_help) entryconfigure 0 -label "About"

if {$woz(sapi)==""} {
	$widget(m_run) entryconfigure 10 -state disabled
	set $var(tts) 0
} else {
	set $var(tts) 1
}

# remove the empty windows
catch {pack unpack $widget(p)}
catch {pack unpack $widget(q)}

image create photo "play" -file $woz(RES)/play.gif
image create photo "stop" -file $woz(RES)/stop.gif
foreach n {q_init q_nu1 q_nu2 q_nu3 q_nr1 q_nr2 q_nr3 q_tl1 q_tl2 q_tl3 q_ctxhelp \
           p_prompt} {
	$widget(ls,$n) configure -image "play" -command "playPrompt $n"
	$widget(stop,$n) configure -image "stop" -command "stopPrompt $n"
}

# set colors for labels
foreach n [array names widget label,c_*] {
	$widget($n) configure -background [ini::Str common.colorC]
}
foreach n [array names widget label,p_*] {
	$widget($n) configure -background [ini::Str common.colorP]
}
foreach n [array names widget label,q_*] {
	$widget($n) configure -background [ini::Str common.colorQ]
}

set global(time) [clock seconds]
set global(turns) 0
set woz(rootname) [file rootname [info script]]

setTime
setDate
bind $widget(main) <Destroy> {menuCommand file,exit}
#bind $widget(main) <Key-BackSpace> {menuCommand run,undo}
bind $widget(main) <Key-Delete> {menuCommand run,undo}
bind $widget(main) <Key-Insert> {menuCommand run,redo}
bind $widget(main) <Key-F1> {menuCommand help,about}
bind $widget(main) <Key-F2> {menuCommand run,restart}
bind $widget(main) <Key-Return> {$widget(logButton) invoke}
focus $widget(logEntry)

splash 2500

# replace {REPROMPTS} in all questions
foreach n [allEntries Q] {
	foreach name $plugin(qix,text) {
		regsub -all -nocase "{REPROMPT}" $plugin($n,$name) $plugin($n,q_init) plugin($n,$name)
	}
}


menuCommand run,restart

