proc moveInit {} {
  global MOVE
  set MOVE(REDO) {}
  set MOVE(UNDO) {}
  set MOVE(#UNDO) 0
  set MOVE(#REDO) 0
  set MOVE(#MOVE) 0
  set MOVE(P) -1
}

proc moveIsUndo {{count 1}} {
  global MOVE
  if {$count=="all"} {set count [expr $MOVE(P)+1]}
  if {$count<=0} {return 0}
  return [expr ($MOVE(P)-$count+1)>=0]
}

proc moveIsRedo {{count 1}} {
  global MOVE
  set l [llength $MOVE(REDO)]
  if {$count=="all"} {set count [expr $l-$MOVE(P)-1]}
  if {$count<=0} {return 0}
  return [expr ($l-$MOVE(P)-$count)>0]
}

proc moveExec {cmd} {
  #puts "Executing $cmd..."
  eval $cmd
}

proc moveAdd {redo undo} {
  global MOVE
  set MOVE(UNDO) [lrange $MOVE(UNDO) 0 $MOVE(P)]
  set MOVE(REDO) [lrange $MOVE(REDO) 0 $MOVE(P)]
  lappend MOVE(REDO) $redo
  lappend MOVE(UNDO) $undo
  incr MOVE(P)
  incr MOVE(#MOVE)
  moveExec $redo
}

proc moveUndo {{count 1}} {
  global MOVE
  if {$count=="all"} {set count [expr $MOVE(P)+1]}
  if {$count<=0} {return 0}
  if {![moveIsUndo $count]} return
  incr MOVE(#UNDO) $count
  for {set i 0} {$i<$count} {incr i} {
    moveExec [lindex $MOVE(UNDO) $MOVE(P)]
    incr MOVE(P) -1
  }
}

proc moveRedo {{count 1}} {
  global MOVE
  set l [llength $MOVE(REDO)]
  if {$count=="all"} {set count [expr $l-$MOVE(P)-1]}
  if {$count<=0} {return 0}
  if {![moveIsRedo $count]} return
  incr MOVE(#REDO) $count
  for {set i 0} {$i<$count} {incr i} {
    incr MOVE(P)
    moveExec [lindex $MOVE(REDO) $MOVE(P)]
  }
}

proc moveCount {} {
  global MOVE
  return $MOVE(#MOVE)
}

proc moveCountUndo {} {
  global MOVE
  return $MOVE(#UNDO)
}

proc moveCountRedo {} {
  global MOVE
  return $MOVE(#REDO)
}
