#==========================================================================================
#
# 	Written by Richard Breuer (richard.breuer@gmx.de)
#
#==========================================================================================
# Feb 19, 2000	First version [RB]
#==========================================================================================

namespace eval dia {

proc ListChoose {w title inList {preSelection {}}} {
  # show a listbox to choose some elements from a list
  global dia::exit
  
  # geometry
  toplevel $w
  wm title $w $title
  frame $w.1
  frame $w.2
  pack $w.1 -expand 1 -fill both
  pack $w.2 -fill x

  set b $w.1.b
  listbox $b -selectmode multiple
  pack $b -expand 1 -fill both

  button $w.2.1 -text Ok -command "set dia::exit 1"
  button $w.2.2 -text Alle -command "$b selection set 0 end"
  button $w.2.3 -text Keine -command "$b selection clear 0 end"
  button $w.2.9 -text Abbrechen -command {set dia::exit 0}  
  pack $w.2.1 $w.2.2 $w.2.3 $w.2.9 -side left -expand 1 -pady 5 -padx 5

  # contents at startup
  set i 0
  foreach e $inList {
    $b insert end $e
    set tmp($i) $e
    incr i
  }

  # selection at startup
  foreach e $preSelection {
    set p [lsearch -exact $inList $e]
    if {$p!=-1} {$b selection set $p}
  }
  
  # dialog
  grab $w
  tkwait variable dia::exit
  grab release $w
  
  # return the selection
  if {$dia::exit} {
    set ret {}
    foreach s [$b curselection] {
      lappend ret [$b get $s]
    }
  } else {
    set ret $preSelection
  }
  
  catch {destroy $w}
  return $ret
}

}