#==========================================================================================
#
# 	Written by Richard Breuer (richard.breuer@gmx.de)
#
#	initialization file handling
#
#==========================================================================================
# Oct 22, 2006	Possible Defaults in Read [RB]
# Jan 02, 2000	Namespace [RB]
# Dec 06, 1999	First Version [RB]
#==========================================================================================

namespace eval ini {

set INI() ""

proc Read {fn {defaults {}}} {
  # read ini file and store its contents in INI
  variable INI

	# read defaults first so that the ini values overwrite them if necessary
	if {$defaults!=""} {Read $defaults}

  catch {
    set f [open $fn r]
    fconfigure $f -encoding utf-8
    set pre "all"
    while {![eof $f]} {
      set l [gets $f]
      if {$l!="" && ![regexp "^\[;#\]" $l]} {
        if {[regexp "^\\\[.*\\\]$" $l]} {
          set pre [string range $l 1 [expr [string length $l]-2]]
        } else {
          set tmp [split $l "="]
          set INI([string tolower $pre.[lindex $tmp 0]]) [lindex $tmp 1]
        }
      }
    }
    close $f
  }

  #puts "[array get INI]"
}

proc Exists {strix} {
  variable INI
  set strix [string tolower $strix]
  return [info exists INI($strix)]
}

proc Str {strix args} {
  variable INI

  set strix [string tolower $strix]
  if {[info exists INI($strix)]} {
    if {$args=={}} {
      return $INI($strix)
    } else {
      return [eval format \"$INI($strix)\" $args]
    }
  } else {
    return ""
  }
}

}