namespace eval move {

proc init {{domain "global"}} {
  global MOVE
  set MOVE(REDO,$domain) {}
  set MOVE(UNDO,$domain) {}
  set MOVE(#UNDO,$domain) 0
  set MOVE(#REDO,$domain) 0
  set MOVE(#MOVE,$domain) 0
  set MOVE(P,$domain) -1
}

proc debug {{domain "global"}} {
  global MOVE
  puts "[array get MOVE *,$domain]"
	tk_messageBox -message "[array get MOVE *,$domain]" -type ok
}

proc isUndo {{count 1} {domain "global"}} {
  global MOVE
  if {$count=="all"} {set count [expr $MOVE(P,$domain)+1]}
  if {$count<=0} {return 0}
  return [expr ($MOVE(P,$domain)-$count+1)>=0]
}

proc isRedo {{count 1} {domain "global"}} {
  global MOVE
  set l [llength $MOVE(REDO,$domain)]
  if {$count=="all"} {set count [expr $l-$MOVE(P,$domain)-1]}
  if {$count<=0} {return 0}
  return [expr ($l-$MOVE(P,$domain)-$count)>0]
}

proc lastUndoComment {{default "Nothing to Undo"} {domain "global"}} {
  global MOVE
	if {[isUndo 1 $domain]} {
		return [lindex [lindex $MOVE(UNDO,$domain) $MOVE(P,$domain)] 1]
	} else {
		return $default
	}
}

proc nextRedoComment {{default "Nothing to Redo"} {domain "global"}} {
  global MOVE
	if {[isRedo 1 $domain]} {
		return [lindex [lindex $MOVE(REDO,$domain) [expr 1+$MOVE(P,$domain)]] 1]
	} else {
		return $default
	}
}

proc add {redo undo {comment ""} {exec 1} {domain "global"}} {
  global MOVE plugin curobj
  set MOVE(UNDO,$domain) [lrange $MOVE(UNDO,$domain) 0 $MOVE(P,$domain)]
  set MOVE(REDO,$domain) [lrange $MOVE(REDO,$domain) 0 $MOVE(P,$domain)]
  lappend MOVE(REDO,$domain) [list $redo $comment]
  lappend MOVE(UNDO,$domain) [list $undo $comment]
  incr MOVE(P,$domain)
  incr MOVE(#MOVE,$domain)
  if {$exec} {eval $redo}
  updateUndoRedo $domain
}

proc undo {{count 1} {domain "global"}} {
  global MOVE plugin curobj
  if {$count=="all"} {set count [expr $MOVE(P,$domain)+1]}
  if {$count<=0} {return 0}
  if {![isUndo $count $domain]} return
  incr MOVE(#UNDO,$domain) $count
  for {set i 0} {$i<$count} {incr i} {
    eval [lindex [lindex $MOVE(UNDO,$domain) $MOVE(P,$domain)] 0]
    incr MOVE(P,$domain) -1
  }
  updateUndoRedo $domain
}

proc redo {{count 1} {domain "global"}} {
  global MOVE plugin curobj
  set l [llength $MOVE(REDO,$domain)]
  if {$count=="all"} {set count [expr $l-$MOVE(P,$domain)-1]}
  if {$count<=0} {return 0}
  if {![isRedo $count $domain]} return
  incr MOVE(#REDO,$domain) $count
  for {set i 0} {$i<$count} {incr i} {
    incr MOVE(P,$domain)
    eval [lindex [lindex $MOVE(REDO,$domain) $MOVE(P,$domain)] 0]
  }
  updateUndoRedo $domain
}

proc count {{domain "global"}} {
  global MOVE
  return $MOVE(#MOVE,$domain)
}

proc countUndo {{domain "global"}} {
  global MOVE
  return $MOVE(#UNDO,$domain)
}

proc countRedo {{domain "global"}} {
  global MOVE
  return $MOVE(#REDO,$domain)
}

}