#set plugin(S001,s_id) S001
#set plugin(S001,s_name) "First Call"
#set plugin(S001,s_memo) "Caller is directed by the application"
#set plugin(S001,s_call) {{P004 "test text"} {Q001 q_init "asgxd ag" dtmf 1} {Q002 q_nu1 "wehg jwedgweg" text "I need a room"} {Pnew ""}}

proc changeTurn {ix obj w1 w2} {
	global curobj plugin widget

	set turn [lindex $curobj(s_call) $ix]
	set changed 0

	if {$ix!=0} {
		set previd [lindex [lindex $curobj(s_call) [expr $ix-1]] 0]
	} else {
		set previd ""
	}

	switch $obj {
		pobj {
			set tmp [dia::chooseFollowPQsingle $previd [concat Pnew [allEntries P]]]
			if {$tmp!=""} {
				set changed 1

				# transfer the current texts into curobj
				saveTextContents

				$w1 configure -text $tmp
				$w2 delete 0.0 end

				set turn [lreplace $turn 0 0 $tmp]
				if {$tmp!="Pnew"} {
					set tmp $plugin($tmp,p_prompt)
				} else {
					set tmp [lindex $turn 1]
				}
				$w2 insert end $tmp
				set turn [lreplace $turn 1 1 $tmp]

				set undo_cmd "set curobj(s_call) [list $curobj(s_call)]"
				set redo_cmd "set curobj(s_call) [list [lreplace $curobj(s_call) $ix $ix $turn]]"

			}
		}
		qobj {
			set tmp [dia::chooseFollowPQsingle $previd [concat Qnew [allEntries Q]]]
			if {$tmp!=""} {
				set changed 1

				# transfer the current texts into curobj
				saveTextContents

				$w1 configure -text $tmp
				$w2 delete 0.0 end

				set turn [lreplace $turn 0 0 $tmp]
				if {$tmp!="Qnew"} {
					set tmp $plugin($tmp,[lindex $turn 1])
				} else {
					set tmp [lindex $turn 2]
				}
				$w2 insert end $tmp
				set turn [lreplace $turn 2 2 $tmp]

				set undo_cmd "set curobj(s_call) [list $curobj(s_call)]"
				set redo_cmd "set curobj(s_call) [list [lreplace $curobj(s_call) $ix $ix $turn]]"
			}
		}
		sub {
			set tmp [lindex [dia::chooseSingle $plugin(qix,phr)] 0]
			if {$tmp!=""} {
				set changed 1

				# transfer the current texts into curobj
				saveTextContents

				$w1 configure -text $tmp
				$w2 delete 0.0 end

				set turn [lreplace $turn 1 1 $tmp]
				if {[lindex $turn 0]!="Qnew"} {
					set tmp $plugin([lindex $turn 0],$tmp)
				} else {
					set tmp [lindex $turn 2]
				}
				$w2 insert end $tmp
				set turn [lreplace $turn 2 2 $tmp]

				set undo_cmd "set curobj(s_call) [list $curobj(s_call)]"
				set redo_cmd "set curobj(s_call) [list [lreplace $curobj(s_call) $ix $ix $turn]]"
			}
		}
		type {
			set tmp [dia::chooseSingle {text dtmf noinput}]
			if {$tmp!="" && $tmp!=[lindex $turn 3]} {
				set changed 1

				# transfer the current texts into curobj
				saveTextContents

				$w1 configure -text $tmp
				set turn [lreplace $turn 3 3 $tmp]

				set undo_cmd "set curobj(s_call) [list $curobj(s_call)]"
				set redo_cmd "set curobj(s_call) [list [lreplace $curobj(s_call) $ix $ix $turn]]"
			}
		}
	}
	
	if {$changed} {
		move::add $redo_cmd $undo_cmd [res::Str undo_change $curobj(s_id)] 1 s_call
		createSampleCallWidgets $curobj(s_id) $widget(s_call)
	}
}

proc deleteTurn {ix w} {
	global curobj widget

	# transfer the current texts into curobj
	saveTextContents

	# adjust curobj
	set p [lsearch -exact $curobj(turns) $ix]

	set redo_cmd "set curobj(s_call) [list [lreplace $curobj(s_call) $p $p]]"
	set undo_cmd "set curobj(s_call) [list $curobj(s_call)]"

	move::add $redo_cmd $undo_cmd [res::Str undo_change $curobj(s_id)] 1 s_call
	createSampleCallWidgets $curobj(s_id) $widget(s_call)
}

proc moveTurn {ix amount w} {
	# amount may be 1 or -1
	global curobj widget

	if {$amount!=1&&$amount!=-1} {return}
	
	# calculate new position, return if nothing to shift
	set p [lsearch -exact $curobj(turns) $ix]
	set pnew [expr $p+$amount]
	if {$pnew<0||$pnew>=[llength $curobj(turns)]} {return}

	# transfer the current texts into curobj
	saveTextContents

	# move the contents
	set tmp [lindex $curobj(s_call) $p]
	set tmp2 [lreplace $curobj(s_call) $p $p]

	set redo_cmd "set curobj(s_call) [list [linsert $tmp2 $pnew $tmp]]"
	set undo_cmd "set curobj(s_call) [list $curobj(s_call)]"

	move::add $redo_cmd $undo_cmd [res::Str undo_change $curobj(s_id)] 1 s_call
	createSampleCallWidgets $curobj(s_id) $widget(s_call)
}

proc appendSampleCallPrompt {} {
	global widget curobj plugin

	set tmp ""
	# the first prompt is - if possible - the welcome prompt
	if {$curobj(s_call)=={}} {set tmp [getStartPrompt]}

	if {$tmp!=""} {
		set turn [list $tmp $plugin($tmp,p_prompt)]
	} else {
		saveTextContents
		set turn [list Pnew ""]
	}

	set tmp $curobj(s_call);
	lappend tmp $turn

	set undo_cmd "set curobj(s_call) [list $curobj(s_call)]"
	set redo_cmd "set curobj(s_call) [list $tmp]"
	
	set ix $curobj(nextix)
	incr curobj(nextix)

	move::add $redo_cmd $undo_cmd [res::Str undo_new_prompt "Pnew"] 1 s_call

	createSampleCallWidgets $curobj(s_id) $widget(s_call)

	# display the new object
	$widget(s_call) yview moveto 1.0
}

proc appendSampleCallQuestion {} {
	global widget curobj

	saveTextContents
	set turn [list Qnew q_init "" text ""]

	set tmp $curobj(s_call);
	lappend tmp $turn

	set undo_cmd "set curobj(s_call) [list $curobj(s_call)]"
	set redo_cmd "set curobj(s_call) [list $tmp]"
	
	set ix $curobj(nextix)
	incr curobj(nextix)

	move::add $redo_cmd $undo_cmd [res::Str undo_new_question "Qnew"] 1 s_call

	createSampleCallWidgets $curobj(s_id) $widget(s_call)

	# display the new object
	$widget(s_call) yview moveto 1.0
}

proc createPromptWidget {turn w ix activeUp activeDown} {
	global plugin curobj

	set pid [lindex $turn 0]
	set ptext [lindex $turn 1]

	# start prompt?
	if {[promptExists $pid] && $plugin($pid,p_start)==1} {
		set col [ini::Str common.colorP1]
	} else {
		set col [ini::Str common.colorP]
	}

	frame $w.f$ix -background $col -relief raised -borderwidth 2

	label $w.f$ix.l -text "[expr 1+$ix]" -width 3 \
		-background white -relief sunken

	label $w.f$ix.0 -text "Prompt" -width 10 -background $col

	button $w.f$ix.1 -text $pid -command "changeTurn $ix pobj $w.f$ix.1 $w.f$ix.3" -width 6

	button $w.f$ix.2 -text p_prompt -state disabled -width 10

	text $w.f$ix.3 -background {white} -height 3 \
		-width [ini::Str Graphics.scPQlength] -wrap word
	$w.f$ix.3 delete 0.0 end
	if {$pid!="Pnew" && ![promptExists $pid]} {
		set col [ini::Str Common.colorSwarn]
	} else {
		if {$pid!="Pnew" && $ptext!=$plugin($pid,p_prompt)} {
			set col [ini::Str Common.colorSwarn]
		} else {
			set col black
		}
	}
	$w.f$ix.3 configure -foreground $col
	$w.f$ix.3 insert end $ptext

	button $w.f$ix.97 -text "del" -image s_delete -command "deleteTurn $ix $w.f$ix"
	button $w.f$ix.98 -text "^" -image s_up -command "moveTurn $ix -1 $w.f$ix"
	button $w.f$ix.99 -text "v" -image s_down -command "moveTurn $ix 1 $w.f$ix"
	button $w.f$ix.9a -text "p" -image playsmall -command "playPrompt $w.f$ix.3"

	if {!$activeUp} {$w.f$ix.98 configure -state disabled}
	if {!$activeDown} {$w.f$ix.99 configure -state disabled}

	pack $w.f$ix.l -side left
	pack $w.f$ix.0 -side left
	pack $w.f$ix.1 -side left
	pack $w.f$ix.2 -side left
	pack $w.f$ix.3 -side left -expand 1 -fill x
	pack $w.f$ix.97 -side left
	pack $w.f$ix.98 -side left
	pack $w.f$ix.99 -side left
	pack $w.f$ix.9a -side left

	return $w.f$ix
}

proc createQuestionWidget {turn w ix activeUp activeDown} {
	global plugin curobj

	set qid [lindex $turn 0]
	set qsub [lindex $turn 1]
	set qtext [lindex $turn 2]
	set ctype [lindex $turn 3]
	set ctext [lindex $turn 4]

	frame $w.f$ix -relief raised -borderwidth 2
	frame $w.f$ix.s -background [ini::Str common.colorQ]
	frame $w.f$ix.c -background [ini::Str common.colorQ]
	pack $w.f$ix.s $w.f$ix.c -fill x

	# the question part
	label $w.f$ix.s.l -text "[expr 1+$ix]" -width 3 \
		-background white -relief sunken

	label $w.f$ix.s.0 -text "Question" -width 10 -background [ini::Str common.colorQ]

	button $w.f$ix.s.1 -text $qid -command "changeTurn $ix qobj $w.f$ix.s.1 $w.f$ix.s.3" -width 6

	button $w.f$ix.s.2 -text $qsub -command "changeTurn $ix sub $w.f$ix.s.2 $w.f$ix.s.3" -width 10

	text $w.f$ix.s.3 -background {white} -height 3 \
		-width [ini::Str Graphics.scPQlength] -wrap word
	$w.f$ix.s.3 delete 0.0 end
	if {$qid!="Qnew" && ![questionExists $qid]} {
		set col [ini::Str Common.colorSwarn]
	} else {
		if {$qid!="Qnew" && $qtext!=$plugin($qid,$qsub)} {
			set col [ini::Str Common.colorSwarn]
		} else {
			set col black
		}
	}
	$w.f$ix.s.3 configure -foreground $col
	$w.f$ix.s.3 insert end $qtext

	button $w.f$ix.s.97 -text "del" -image s_delete -command "deleteTurn $ix $w.f$ix"
	button $w.f$ix.s.98 -text "^" -image s_up -command "moveTurn $ix -1 $w.f$ix"
	button $w.f$ix.s.99 -text "v" -image s_down -command "moveTurn $ix 1 $w.f$ix"
	button $w.f$ix.s.9a -text "p" -image playsmall -command "playPrompt $w.f$ix.s.3"

	if {!$activeUp} {$w.f$ix.s.98 configure -state disabled}
	if {!$activeDown} {$w.f$ix.s.99 configure -state disabled}

	pack $w.f$ix.s.l -side left
	pack $w.f$ix.s.0 -side left
	pack $w.f$ix.s.1 -side left
	pack $w.f$ix.s.2 -side left
	pack $w.f$ix.s.3 -side left -expand 1 -fill x
	pack $w.f$ix.s.97 -side left
	pack $w.f$ix.s.98 -side left
	pack $w.f$ix.s.99 -side left
	pack $w.f$ix.s.9a -side left

	# the caller part
	label $w.f$ix.c.l -width 3 \
		-background [ini::Str common.colorQ] -relief flat

	label $w.f$ix.c.0 -text "Caller" -width 10 -background [ini::Str common.colorQ]

	frame $w.f$ix.c.1 -width [winfo reqwidth $w.f$ix.s.1] -height 1 -background [ini::Str common.colorQ]

	button $w.f$ix.c.2 -text $ctype -command "changeTurn $ix type $w.f$ix.c.2 $w.f$ix.c.3" -width 10

	text $w.f$ix.c.3 -background {white} -height 2 -width [ini::Str Graphics.scClength]
	$w.f$ix.c.3 delete 0.0 end
	$w.f$ix.c.3 insert end $ctext

	pack $w.f$ix.c.l -side left
	pack $w.f$ix.c.0 -side left
	pack $w.f$ix.c.1 -side left
	pack $w.f$ix.c.2 -side left
	pack $w.f$ix.c.3 -side left -expand 1 -fill x

	return $w.f$ix
}

proc saveTextContents {} {
	# ...transfer the text fields contents to curobj(s_call)
	# and return the necessary commands.
	global curobj widget

	set w $widget(s_call)
	set ret {}
	set ix 0
	foreach turn $curobj(s_call) {
		if {[isPrompt [lindex $turn 0]]} {
			set turn [lreplace $turn 1 1 [string trim [$w.f$ix.3 get 0.0 end]]]
		} else {
			set turn [lreplace $turn 2 2 [string trim [$w.f$ix.s.3 get 0.0 end]]]
			set turn [lreplace $turn 4 4 [string trim [$w.f$ix.c.3 get 0.0 end]]]
		}
		lappend ret $turn
		incr ix
	}
	set curobj(s_call) $ret
}

proc createAndPackWidget {turn w ix activeUp activeDown} {
	global widget curobj

	# get current coordinate
	if {$ix==0} {
	  set y 0
	} else {
	  set y $curobj(y,[expr $ix-1])
	}

	incr y [ini::Str Graphics.scOffsetY]
	
	# create widgets
	set curr [lindex $turn 0]
	if {[isPrompt $curr]} {
		set subw [createPromptWidget $turn $w $ix $activeUp $activeDown]
	} else {
		set subw [createQuestionWidget $turn $w $ix $activeUp $activeDown]
	}

	# pack widget and calculate new coordinates
	set curobj(id,$ix) [$widget(s_call) create window [ini::Str Graphics.scOffsetX] $y -anchor nw -window $subw]
	update
	incr y [winfo reqheight $subw]
	set curobj(y,$ix) $y
}

proc defineScrollRegion {{region {}}} {
	global widget

	if {$region=={}} {
		set region [$widget(s_call) bbox all]
		set region [lreplace $region 0 1 0 0]
	}
	
	$widget(s_call) configure -scrollregion $region
}

proc createSampleCallWidgets {id w} {
	# create all widgets for displaying the sample call $id
	# and pack them into $w; $w is cleared first
	global widget curobj

	eval destroy [winfo children $w]

	# loop over all dialog turns to create a frame for each
	set ix 0
	set curobj(turns) {}

	foreach turn $curobj(s_call) {
		createAndPackWidget $turn $w $ix [expr $ix!=0] [expr $ix<[llength $curobj(s_call)]-1]
		lappend curobj(turns) $ix
		incr ix
	}
	set curobj(nextix) $ix

	if {$curobj(turns)!={}} {
		defineScrollRegion [list 0 0 0 $curobj(y,[expr $ix-1])]
	}
	updateUndoRedo "s_call"
}

proc scSync {id} {
	global widget var
	set var(sync) $id
	set var(undoDomain) ""
	::vTcl:Toplevel:WidgetProc $widget(sync_sc) startmodal
}

proc syncSampleCalls {{callList {}} {undoDomain {}}} {
	global widget options plugin statusMsg

	set undo_cmd ""
	set redo_cmd ""
	set changed 0
	set keepsyncing 1

	set reservedP ""
	set reservedQ ""
	
	set newP 0
	set newQ 0
	set newO 0
	set newC 0

	if {$callList=={}} {set callList [allEntries S]}

	while {$keepsyncing} {
		foreach call $callList {
			set ix 0
			set changedThisCall 0
			set s_call $plugin($call,s_call)
			
			foreach turn $plugin($call,s_call) {
				set id [lindex $turn 0]
	
				# sc_create_missing_obj --> create new object when a used object in a sample call is missing
				# sc_create_new_obj --> create new object (Pnew, Qnew) when used in a sample call
				if {
					(	$options(sc_create_missing_obj) && 
				  	[isPrompt $id] && 
				  	![promptExists $id] && 
				  	$id!="Pnew" ) ||
				  ( $options(sc_create_new_obj) && 
				  	$id=="Pnew" )
				} {
					set changed 1
					set changedThisCall 1
	
					# create a new prompt to replace the missing one
			    set reservedP [nextId "P" $reservedP]
					set cmd [createPromptCommands $reservedP]
					append redo_cmd "[lindex $cmd 0];"
					set undo_cmd "[lindex $cmd 1]; $undo_cmd;"
	
					incr newP
	
					# replace the text of the new prompt with the text of the sample call
					append redo_cmd "set plugin($reservedP,p_prompt) [list [lindex $turn 1]];"
	
					# replace the missing one
					set turn [lreplace $turn 0 0 $reservedP]
					set s_call [lreplace $s_call $ix $ix $turn]
				} elseif {
					( $options(sc_create_missing_obj) && 
				 		[isQuestion $id] && 
				  	![questionExists $id] && 
				  	$id!="Qnew" ) ||
				  ( $options(sc_create_new_obj) && 
				  	$id=="Qnew" )
				} {
					set changed 1
					set changedThisCall 1
	
					# create a new prompt to replace the missing one
			    set reservedQ [nextId "Q" $reservedQ]
					set cmd [createQuestionCommands $reservedQ]
					append redo_cmd "[lindex $cmd 0];"
					set undo_cmd "[lindex $cmd 1]; $undo_cmd;"
	
					incr newQ
	
					# replace the right text of the new question with the text of the sample call
					append redo_cmd "set plugin($reservedQ,[lindex $turn 1]) [list [lindex $turn 2]];"
	
					# replace the missing one
					set turn [lreplace $turn 0 0 $reservedQ]
					set s_call [lreplace $s_call $ix $ix $turn]
				}
				incr ix
			}
			if {$changedThisCall} {
				set undo_cmd "set plugin($call,s_call) [list $plugin($call,s_call)]; $undo_cmd;"
				append redo_cmd "set plugin($call,s_call) [list $s_call];"
			}
		}
	
		# create new connections?
		if {$options(sc_create_new_connections)} {
			foreach call $callList {
				set last ""
				foreach turn $plugin($call,s_call) {
					# get the current obj
					set curr [lindex $turn 0]
	
					# only proceed with current, if it already exists
					if {
						$curr=="Pnew" || 
						$curr=="Qnew" || 
						![objectExists $curr]
					} {set curr ""}
		
					# check if the connection exists
					if {$last!="" && $curr!="" && $last!=$curr} {
						if {
							[isPrompt $last] && 
							[lsearch -exact $plugin($last,p_follows) $curr]==-1
						} {
							# create connection
							append redo_cmd "set plugin($last,p_follows) [list [concat $plugin($last,p_follows) $curr]];"
							set undo_cmd "set plugin($last,p_follows) [list $plugin($last,p_follows)]; $undo_cmd;"
	
							incr newO
							set changed 1
						} elseif {
							[isQuestion $last] && 
							[lsearch -exact $plugin($last,q_follows) $curr]==-1
						} {
							# create connection
							append redo_cmd "set plugin($last,q_follows) [list [concat $plugin($last,q_follows) $curr]];"
							set undo_cmd "set plugin($last,q_follows) [list $plugin($last,q_follows)]; $undo_cmd;"
	
							# store caller utterance as connection condition
							append redo_cmd "set plugin(O,$last,$curr) [list $lastAnswer];"
							set undo_cmd "array unset plugin O,$last,$curr; $undo_cmd;"
	
							incr newO
							set changed 1
						}
					}
		
					set last $curr
					set lastAnswer [res::Str answer_template [lindex $turn 4]]
				}
			}
		}

		set id ""

		# create new concepts?
		if {$options(sc_create_new_concepts)} {
			foreach call $callList {
				foreach turn $plugin($call,s_call) {
					# get the current obj
					set curr [lindex $turn 0]
	
					# only proceed with current, if it is a question and already exists
					if {
						[isQuestion $curr] &&
						[objectExists $curr]
					} {
						if {$plugin($curr,q_concepts)==""} {
							# create concept
							set id [nextId "C" $id]
							set commands [createConceptCommands $id]
							append redo_cmd [lindex $commands 0]
							set undo_cmd [lindex $commands 1]

							# assign the concept to the question, store the answer in the concept
							append redo_cmd "set plugin($id,c_memo) [list [lindex $turn 4]];"
							append redo_cmd "set plugin($curr,q_concepts) [list $id];"
							append undo_cmd "set plugin($curr,q_concepts) [list {}];"
	
							incr newC
							set changed 1
						}
					}
				}
			}
		}

		# the following changes will not make another sync necessary
		set keepsyncing $changed

		# synchronize wordings?
    if {$options(sc_update_wordings)!="do_nothing"} {
			foreach call $callList {
				set ix 0
				set changedThisCall 0
				set s_call $plugin($call,s_call)

				foreach turn $plugin($call,s_call) {
					set id [lindex $turn 0]
					if {[isPrompt $id] && [promptExists $id]} {
						if {$plugin($id,p_prompt)!=[lindex $turn 1]} {
							if {$options(sc_update_wordings)=="update_design"} {
								append redo_cmd "set plugin($id,p_prompt) [list [lindex $turn 1]];"
								set undo_cmd "set plugin($id,p_prompt) [list $plugin($id,p_prompt)]; $undo_cmd;"
								set changed 1
							} else {
								set turn [lreplace $turn 1 1 $plugin($id,p_prompt)]
								set s_call [lreplace $s_call $ix $ix $turn]
								set changed 1
								set changedThisCall 1
							}
						}
					} elseif {[isQuestion $id] && [questionExists $id]} {
						if {$plugin($id,[lindex $turn 1])!=[lindex $turn 2]} {
							if {$options(sc_update_wordings)=="update_design"} {
								append redo_cmd "set plugin($id,[lindex $turn 1]) [list [lindex $turn 2]];"
								set undo_cmd "set plugin($id,[lindex $turn 1]) [list $plugin($id,[lindex $turn 1])]; $undo_cmd;"
								set changed 1
							} else {
								set turn [lreplace $turn 2 2 $plugin($id,[lindex $turn 1])]
								set s_call [lreplace $s_call $ix $ix $turn]
								set changed 1
								set changedThisCall 1
							}
						}
					}
					incr ix
				}
				if {$changedThisCall} {
					set undo_cmd "set plugin($call,s_call) [list $plugin($call,s_call)]; $undo_cmd;"
					append redo_cmd "set plugin($call,s_call) [list $s_call];"
				}
			}
    }

		if {$changed} {
			move::add $redo_cmd $undo_cmd [res::Str undo_sync $callList]
			prjFlags - 1 -
			updateList
			set changed 0
	  }
	}

	if {[expr $newP+$newQ+$newO+$newC]>0} {
	  set statusMsg [res::Str prjsynced $callList $newP $newQ $newO]
  } else {
	  set statusMsg [res::Str prjnosync $callList]
  }
}

proc createSoundObjectForText {str {pauseFn ""} {forceRandom 0}} {
	# creates a sound object for the string
	# alternatives are randomly chosen
	# a pause is inserted afterwards, if specified
	global plugin woz

	# create a sound object for the prompt
	set ret [play::processPrompt $str 0 $forceRandom]

	# insert a pause if necessary
	if {$ret!=""} {
		set sub [snack::sound]
		if {[catch {$sub read $pauseFn}]} {
	    tk_messageBox -type ok -message "Audio file '$pauseFn' cannot be read!"
		} else {
			if {[catch {$ret concatenate $sub}]} {
		    tk_messageBox -type ok -message "Audio file '$pauseFn'
has a different audio format!"
			}
			$sub destroy
		}
	}

	return $ret
}

proc createSoundObjectFromSampleCall {id {forceRandom 0}} {
	global plugin woz
	
	set ret ""
	
	foreach turn $plugin($id,s_call) {
		set tmpid [lindex $turn 0]
		if {[isPrompt $tmpid]} {
			# the prompt
			set sub [createSoundObjectForText [lindex $turn 1] [ini::Str files.pauseAfterPrompt] $forceRandom]
			if {$sub!=""} {
				if {$ret==""} {set ret $sub} else {
					if {[catch {$ret concatenate $sub}]} {
				    tk_messageBox -type ok -message "Audio file for $tmpid from $id
has a different audio format!"
					}
				}
			}
		} elseif {[isQuestion $tmpid]} {
			# the question
			set sub [createSoundObjectForText [lindex $turn 2] [ini::Str files.pauseAfterQuestion] $forceRandom]
			if {$sub!=""} {
				if {$ret==""} {set ret $sub} else {
					if {[catch {$ret concatenate $sub}]} {
				    tk_messageBox -type ok -message "Audio file for $tmpid (system) from $id
has a different audio format!"
					}
				}
			}
			# the caller's utterance
			set sub [createSoundObjectForText [lindex $turn 4] [ini::Str files.pauseAfterCaller] $forceRandom]
			if {$sub!=""} {
				if {$ret==""} {set ret $sub} else {
					if {[catch {$ret concatenate $sub}]} {
				    tk_messageBox -type ok -message "Audio file for $tmpid (caller) from $id
has a different audio format!"
					}
				}
			}
		}
	}
	return $ret
}

proc generateSampleCalls {{maxOcc 1} {tillEnd 1} {minLength 0} {maxLength 9999} {mustInc {}}} {
	# return a list of sample calls, in which one dialog state occurs at most
	# $maxOcc times
	global plugin

	proc _maxVisits {occ} {
		# find the state with the most visits in the call
		set occ [lsort $occ]
		set v {}
		set m 0
		set ret 0
		foreach state $occ {
			if {$v==""} {
				set v $state
				set m 0
			}
			if {$state==$v} {
				incr m
			} else {
				set ret [util::max $ret $m]
				set m 1
				set v $state
			}
		}
		return [util::max $ret $m]
	}

	proc _generateSCalternatives {cobj maxv occ maxl} {
		global plugin
		set ret $cobj

#puts "_generateSCalternatives($cobj,$maxv,$occ,$maxl): successors of $cobj are [calcSuccessors $cobj]"

		foreach followup [calcSuccessors $cobj] {
			if {[llength $occ]<=$maxl} {
				if {[_maxVisits $occ]<=$maxv} {
					foreach fup [_generateSCalternatives $followup $maxv [concat $occ $followup] $maxl] {
						lappend ret [concat $cobj $fup]
					}
				} else {
#puts "!maxvisits $occ = [_maxVisits $occ]"
				}
			} else {
#puts "!length"
			}
		}
#puts "returns $ret"
		return $ret
	}

	proc _checkMustInc {call mustInc} {
		foreach mi $mustInc {
			if {[lsearch -exact $call $mi]==-1} {return 0}
		}
		return 1
	}
	
	set cobj [getStartPrompt]
	if {$cobj==""} return
	
	set rettmp [lsort -uniq [_generateSCalternatives $cobj $maxOcc $cobj $maxLength]]
	set ret {}
	foreach call $rettmp {
		if {[llength $call]>=$minLength && [llength $call]<=$maxLength} {
			if {!$tillEnd || [isEndState [lindex $call end]]} {
				if {[_checkMustInc $call $mustInc]} {
					lappend ret $call
				}
			}
		}
	}

	return $ret
}

proc completeSampleCalls {callList} {
	# create a list of complete sample calls
	global plugin

	# new call ID's
	set num 0
	set newid {}
	set undo_cmd ""
	set redo_cmd ""
	
	# for all sample calls in the list
	foreach call $callList {
		# create the sample call object and reserve it for the next calls
		set newid [nextId S $newid]

		# not more than 999 sample calls!
		if {$newid==""} {
			tk_messageBox -type ok -message "Too many calls, modify settings!"
			return
		}
		
		incr num

		append undo_cmd "array unset plugin $newid,*;"
		append redo_cmd "set plugin($newid,s_id) [list $newid];"
		append redo_cmd "set plugin($newid,s_name) \"$call\";"
		append redo_cmd "set plugin($newid,s_memo) \"Generated [date::nowS]\";"
		append redo_cmd "set plugin($newid,s_call) [list {}];"

		# loop over the dialog states of the sample call
		foreach state $call {
			if {[isPrompt $state]} {
				append redo_cmd "lappend plugin($newid,s_call) \[list [list $state $plugin($state,p_prompt)]\];"
			} elseif {[isQuestion $state]} {
				append redo_cmd "lappend plugin($newid,s_call) \[list [list $state q_init $plugin($state,q_init) text {}]\];"
			}
		}
	}

	if {$num>0} {
		move::add $redo_cmd $undo_cmd [res::Str undo_autocalls $num] 1
		prjFlags - 1 -
		updateList
	}
}
